<template>
  <div class="body">
    <v-row>
      <v-col cols="3" />
      <v-col cols="9" align="center">
        <head-bar title="Login" />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12" align="center">
        <v-img
          aspect-ratio="1.7778"
          src="http://freedesignfile.com/upload/2016/05/Healthy-eating-logo-design-vector-set-11.jpg"
          height="300px"
          width="300px"
        />
        <v-divider class="ma-6"></v-divider>
      </v-col>
    </v-row>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-row>
        <v-col cols="2" />
        <v-col cols="4" align="right">
          <v-text-field
            v-model="profile.email"
            outlined
            label="Email"
          ></v-text-field>
        </v-col>
        <v-col cols="4" align="left">
          <v-text-field
            v-model="profile.password"
            outlined
            label="password"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="4" align="center">
          <v-btn color="success" :disabled="!valid" to="/signin"
            >Create an account</v-btn
          >
        </v-col>
        <v-col cols="4" align="center">
          <v-btn color="primary" :disabled="!valid" @click="Connect"
            >Connect</v-btn
          ></v-col
        >
        <v-col cols="4" align="center">
          <v-btn color="red darken-1" :disabled="!valid" @click="ForgotPassword"
            >Forgot password</v-btn
          >
        </v-col>
      </v-row>
    </v-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      valid: true,
      profile: {
        email: '',
        password: '',
      },
      emailRules: [(v: string) => !!v || 'Email is required'],
      passwordRules: [(v: string) => !!v || 'This field is required'],
    }
  },
  methods: {
    Connect(): void {
      if ((this.$refs.form as any).validate()) {
        // Client-Side
        this.$axios
          .post('/login', {
            email: this.profile.email,
            password: this.profile.password,
          })
          .then((response) => {
            //create token
            const accessToken = response.data.accessToken
            const refreshToken = response.data.refreshToken

            this.$store.state.storeAccessTokenInLocalStorage(accessToken)
            this.$store.state.storeRefreshTokenInLocalStorage(refreshToken)
          })
          .catch((error) => {
            this.$store.state.alertLoginFailed(error)
          })
      }
    },
    ForgotPassword(): void {
      if ((this.$refs.form as any).validate()) {
        // TODO: AXIOS submit
      }
    },
  },
})
</script>
